//===============================================================================
//         Developed As An Addition To Matt Pietrek's LibCTiny.lib
//                      By Fred Harris, January 2016
//
//                cl atol.cpp /c /W3 /DWIN32_LEAN_AND_MEAN 
//===============================================================================
#include <stdlib.h>

extern "C" long __cdecl atol ( const char * pstr )
{
 int  cCurr;                       // The current character.
 long lTotal;                      // The running total.
 int  iIsNeg;                      // Holds the '-' sign.

 while(*pstr==32)
 {
    ++pstr;
 }
 cCurr = *pstr++;                  // Get the current character.
 iIsNeg = cCurr;                   // Save the negative sign.
 if(('-'==cCurr)||('+'==cCurr))
     cCurr = *pstr++ ;             // We have a sign, so skip it.
 lTotal = 0 ;                      // Initialize the total.
 while(cCurr>=48 && cCurr<=57)     // While we have digits, addem up.
 {
     lTotal=10*lTotal+(cCurr-'0'); // Add this digit to the total.
     cCurr=*pstr++;                // Do the next character.
 }
 if('-'==iIsNeg)                   // If we have a negative sign, convert the value.
    return(-lTotal);
 else
    return ( lTotal ) ;
}

extern "C" int __cdecl atoi ( const char * pstr )
{
 return ((int)atol(pstr)) ;
}
