// strDemo.cpp
// cl strDemo.cpp Strings.cpp frmOutput.cpp libctiny64.lib Kernel32.lib User32.lib Gdi32.lib /O1 /Os 
#include <windows.h>
#include <string.h>
#include "stdio.h"
#include "Strings.h"
#include "strDemo.h"
#include "frmOutput.h"


long fnWndProc_OnCreate(WndEventArgs& Wea)
{
 char szClassName[]="frmOutput";
 WNDCLASSEX wc;
 HWND hCtrl;
 
 memset(&wc,0,sizeof(wc));
 Wea.hIns=((LPCREATESTRUCT)Wea.lParam)->hInstance;
 wc.lpszClassName=szClassName;                          wc.lpfnWndProc=frmOutput;
 wc.cbSize=sizeof(WNDCLASSEX);                          wc.hIcon=LoadIcon(NULL,IDI_APPLICATION);
 wc.hInstance=Wea.hIns;                                 wc.hCursor=LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);  wc.cbWndExtra=0;
 wc.lpszMenuName=NULL;                                  wc.cbClsExtra=0;
 RegisterClassEx(&wc);
 hCtrl=CreateWindow("button","String Concatenation",WS_CHILD|WS_VISIBLE,25,20,300,25,Wea.hWnd,(HMENU)IDC_CONCATENATION,Wea.hIns,0);
 hCtrl=CreateWindow("button","String Parsing And Trimming",WS_CHILD|WS_VISIBLE,25,55,300,25,Wea.hWnd,(HMENU)IDC_PARSE,Wea.hIns,0);
 hCtrl=CreateWindow("button","Good Old Left, Right, And Mid!",WS_CHILD|WS_VISIBLE,25,90,300,25,Wea.hWnd,(HMENU)IDC_LEFT_RIGHT_MID,Wea.hIns,0);
 hCtrl=CreateWindow("button","But Led's Not Forget InStr( )!",WS_CHILD|WS_VISIBLE,25,125,300,25,Wea.hWnd,(HMENU)IDC_INSTR,Wea.hIns,0);
 hCtrl=CreateWindow("button","Formatting Integers, Doubles And Money",WS_CHILD|WS_VISIBLE,25,160,300,25,Wea.hWnd,(HMENU)IDC_FORMATTING,Wea.hIns,0);
 hLib=LoadLibrary("msvcrt.dll");
 if(hLib)
 {
    pSPrtf=(int (*)(char*, const char*, ...))GetProcAddress(hLib,"sprintf");
    #ifdef x64
       pAbs64=(ssize_t (*)(ssize_t))GetProcAddress(hLib,"_abs64");
       if(!pAbs64)
          return -1;
       pAtoi64=(ssize_t (*)(const char*))GetProcAddress(hLib,"_atoi64");
       if(!pAtoi64)
          return -1;
    #else
       pAbs=(ssize_t (*)(ssize_t))GetProcAddress(hLib,"abs");
       if(!pAbs)
          return -1;
    #endif
 }
 else
    return -1;

 return 0;
}


void btnConcatenation_OnClick(WndEventArgs& Wea)
{
 HINSTANCE hIns=NULL;
 HWND hOutput=NULL;
 HWND hCtl=NULL;
 String s;
 RECT rc;

 hIns=GetModuleHandle(0);
 hOutput=CreateWindowEx(0,"frmOutput","String Class Minipulations In C++",WS_OVERLAPPEDWINDOW,850,20,375,480,0,0,hIns,0);
 GetClientRect(hOutput,&rc);
 hCtl=CreateWindowEx(0,"listbox","",LBS_HASSTRINGS|WS_CHILD|WS_VISIBLE,0,0,rc.right,rc.bottom,hOutput,(HMENU)IDC_LISTBOX,hIns,0);
 ShowWindow(hOutput,SW_SHOWNORMAL);
 for(unsigned int i=65; i<91; i++)
 {
     s=s+i;   //65 Is Capital 'A'
     SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s.lpStr());
 }
}


void btnParse_OnClick(WndEventArgs& Wea)
{
 HINSTANCE hIns=NULL;
 String* ptrStrings;
 int iParseCount;
 HWND hCtl=NULL;
 HWND hOutput;
 String s;
 RECT rc;

 hIns=GetModuleHandle(0);
 hOutput=CreateWindowEx(0,"frmOutput","String Class Minipulations In C++",WS_OVERLAPPEDWINDOW,475,240,375,180,0,0,hIns,0);
 GetClientRect(hOutput,&rc);
 hCtl=CreateWindowEx(0,"listbox","",LBS_HASSTRINGS|WS_CHILD|WS_VISIBLE,0,0,rc.right,rc.bottom,hOutput,(HMENU)IDC_LISTBOX,hIns,0);
 ShowWindow(hOutput,SW_SHOWNORMAL);
 s="Frederick,  Mary,  James,  Samuel,  Edward,  Richard,  Michael,  Joseph";  //Create comma delimited text string
 iParseCount=s.ParseCount(',');                                                //Count delimited substrings
 ptrStrings = new String[iParseCount];                                         //Create array of String Pointers
 s.Parse(ptrStrings,',',iParseCount);                                          //Parse 's' based on comma delimiter
 for(unsigned int i=0; i<iParseCount; i++)
 {
     ptrStrings[i].LTrim();  //Comment This Out To See Effect.                 //There are some spaces in delimited strings so remove them
     SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)ptrStrings[i].lpStr());
 }
 delete [] ptrStrings;
}


void btnLeftRightMid_OnClick(WndEventArgs& Wea)
{
 HINSTANCE hIns=NULL;
 HWND hCtl=NULL;
 HWND hOutput;
 String s1,s2;
 RECT rc;

 hIns=GetModuleHandle(0);
 hOutput=CreateWindowEx(0,"frmOutput","String Class Minipulations In C++",WS_OVERLAPPEDWINDOW,450,40,375,150,0,0,hIns,0);
 GetClientRect(hOutput,&rc);
 hCtl=CreateWindowEx(0,"listbox","",LBS_HASSTRINGS|WS_CHILD|WS_VISIBLE,0,0,rc.right,rc.bottom,hOutput,(HMENU)IDC_LISTBOX,hIns,0);
 ShowWindow(hOutput,SW_SHOWNORMAL);
 s1="George Washington Carver";
 s2=s1.Left(6);
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s1.lpStr());
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s2.lpStr());
 s2=s1.Mid(8,10);
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s2.lpStr());
 s2=s1.Right(6);
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s2.lpStr());
}


void btnInStr_OnClick(WndEventArgs& Wea)
{
 double dblNumber=3.14159;
 HINSTANCE hIns=NULL;
 String s1,s2,s3;
 HWND hCtl=NULL;
 HWND hOutput;
 int iOffset;
 RECT rc;

 hIns=GetModuleHandle(0);
 hOutput=CreateWindowEx(0,"frmOutput","String Class Minipulations In C++",WS_OVERLAPPEDWINDOW,20,500,625,200,0,0,hIns,0);
 GetClientRect(hOutput,&rc);
 hCtl=CreateWindowEx(0,"listbox","",LBS_HASSTRINGS|WS_CHILD|WS_VISIBLE,0,0,rc.right,rc.bottom,hOutput,(HMENU)IDC_LISTBOX,hIns,0);
 ShowWindow(hOutput,SW_SHOWNORMAL);
 s1="InStr('Some Text') Locates The One Based Offset Of Where Something Is At.";
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s1.lpStr());
 s1="C++ Can Be A Real Pain In The Butt To Learn!";
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s1.lpStr());
 iOffset=s1.InStr("real",false,false);
 s2=iOffset;
 s3 ="The Offset Of 'real' In The Above String Is ";
 s3 = s3 + s2 + '.';
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s3.lpStr());
 s3=3.14159;
 s3.LTrim();
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s3.lpStr());
 s2="Note In The Above Code We Used The Case Insensitive Version Of InStr().";
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s2.lpStr());
 s3="We Also Saw We Can Convert A Number (pi) Directly To A String By Simple Assignment.";
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s3.lpStr());
 s3="Let's See If We Can Remove() 'Real' From Our 1st String!";
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s3.lpStr());
 s2=s1.Remove("Real",true);
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s2.lpStr());
 s2="Dieses Program funktioniert aber sehr gut, nicht wahr?";
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s2.lpStr());
}


void btnFormatting_OnClick(WndEventArgs& Wea)
{
 double dblNumber=123456789.87654;
 size_t iNumber1=1234567898;
 HINSTANCE hIns=NULL;
 HWND hCtl=NULL;
 HWND hOutput;
 String s1,s2;
 RECT rc;

 hIns=GetModuleHandle(0);
 hOutput=CreateWindowEx(0,"frmOutput","String Class Minipulations In C++",WS_OVERLAPPEDWINDOW,655,550,775,200,0,0,hIns,0);
 GetClientRect(hOutput,&rc);
 hCtl=CreateWindowEx(0,"listbox","",LBS_HASSTRINGS|WS_CHILD|WS_VISIBLE,0,0,rc.right,rc.bottom,hOutput,(HMENU)IDC_LISTBOX,hIns,0);
 ShowWindow(hOutput,SW_SHOWNORMAL);
 s1="Lets Try Reformatting 1234567898 So As To Put Comma Seperators In The Thousands Place - ";
 s2.Format(iNumber1,14,',',false);
 s1=s1+s2;
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s1.lpStr());
 s1="Will It Work With Negative Numbers? ";
 ssize_t iNumber2=-1234567898;
 s2.Format(iNumber2,14,',',false);
 s1=s1+s2+" Yep! Works Just Fine!";
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s1.lpStr());
 s1="Let's See If We Can't Do The Same Thing With Floating Point C Doubles...";
 s2.Format(dblNumber,18,2);
 s1=s1+s2;
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s1.lpStr());
 s1="But Maybe We Don't Need Commas Seperating Thousands...";
 s2.Format(dblNumber,15,3,true);
 s1=s1+s2;
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s1.lpStr());
 dblNumber=9876.54321;
 s1="Can We Add A dollar Sign In Front Of A Money Formatted Amount? ";
 s2.Money(dblNumber,10,true);
 s1=s1+s2;
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s1.lpStr());
 s1="Can We Specify Location Of dollar Sign In Front Of A Money Formatted Amount? ";
 s2.Money(dblNumber,12,(size_t)1);
 s1=s1+s2;
 SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)s1.lpStr());
}


long fnWndProc_OnCommand(WndEventArgs& Wea)
{
 switch(LOWORD(Wea.wParam))
 {
  case IDC_CONCATENATION:
    btnConcatenation_OnClick(Wea);
    break;
  case IDC_PARSE:
    btnParse_OnClick(Wea);
    break;
  case IDC_LEFT_RIGHT_MID:
    btnLeftRightMid_OnClick(Wea);
    break;
  case IDC_INSTR:
    btnInStr_OnClick(Wea);
    break;
  case IDC_FORMATTING:
    btnFormatting_OnClick(Wea);
    break;
 }

 return 0;
}


long fnWndProc_OnDestroy(WndEventArgs& Wea)
{
 HWND hOutput=NULL;

 do   //Search And Destroy Mission For Any Output Windows Hanging Around
 {
  hOutput=FindWindow("frmOutput","String Class Minipulations In C++");
  if(hOutput)
     SendMessage(hOutput,WM_CLOSE,0,0);
  else
     break;
 }while(true);
 FreeLibrary(hLib);
 PostQuitMessage(0);

 return 0;
}



LRESULT CALLBACK fnWndProc(HWND hwnd, unsigned int msg, WPARAM wParam, LPARAM lParam)
{
 WndEventArgs Wea;

 for(unsigned int i=0; i<dim(EventHandler); i++)
 {
     if(EventHandler[i].iMsg==msg)
     {
        Wea.hWnd=hwnd, Wea.lParam=lParam, Wea.wParam=wParam;
        return (*EventHandler[i].fnPtr)(Wea);
     }
 }

 return (DefWindowProc(hwnd, msg, wParam, lParam));
}


int WINAPI WinMain(HINSTANCE hIns, HINSTANCE hPrevIns, LPSTR lpszArgument, int iShow)
{
 char szClassName[]="strDemo";
 WNDCLASSEX wc;
 MSG messages;
 HWND hWnd;

 wc.lpszClassName=szClassName;                    wc.lpfnWndProc=fnWndProc;
 wc.cbSize=sizeof (WNDCLASSEX);                   wc.style=0;
 wc.hIcon=LoadIcon(NULL,IDI_APPLICATION);         wc.hInstance=hIns;
 wc.hIconSm=LoadIcon(NULL, IDI_APPLICATION);      wc.hCursor=LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);    wc.cbWndExtra=0;
 wc.lpszMenuName=NULL;                            wc.cbClsExtra=0;
 RegisterClassEx(&wc);
 hWnd=CreateWindowEx(0,szClassName,szClassName,WS_OVERLAPPEDWINDOW,50,50,360,250,HWND_DESKTOP,0,hIns,0);
 ShowWindow(hWnd,iShow);
 while(GetMessage(&messages,NULL,0,0))
 {
    TranslateMessage(&messages);
    DispatchMessage(&messages);
 }

 return messages.wParam;
}
