//=====================================================================================
//               Developed As An Addition To Matt Pietrek's LibCTiny.lib
//                            By Fred Harris, January 2016
//
//                     cl strncmp.cpp /c /W3 /DWIN32_LEAN_AND_MEAN 
//=====================================================================================
#include <windows.h>
#include <string.h>
#include <malloc.h>

extern "C" int __cdecl strncmp(const char* str1, const char* str2, size_t count)
{
 size_t iLen1=strlen(str1);
 size_t iLen2=strlen(str2);
 if(count>iLen1)
    return -1;
 if(count>iLen2)
    return 1;
 char* pStr1=(char*)malloc(count+1);
 char* pStr2=(char*)malloc(count+1);
 strncpy(pStr1,str1,count);
 strncpy(pStr2,str2,count);
 pStr1[count]=0;
 pStr2[count]=0;
 int iReturn=strcmp(pStr1,pStr2);
 free(pStr1);
 free(pStr2);

 return iReturn;
}



/*
Compare characters of two strings.

int strncmp(const char* string1, const char* string2, size_t count);

Parameters:

string1, string2       Strings to compare. 
count                  Number of characters to compare. 

Return Values:

The return value indicates the relation of the substrings of string1 and string2 as follows.

Return Value Description
 
< 0 string1 substring less than string2 substring 
0 string1 substring identical to string2 substring 
> 0 string1 substring greater than string2 substring 

Remarks

The strncmp function lexicographically compares, at most, the first count characters in string1 
and string2 and returns a value indicating the relationship between the substrings. strncmp is 
case-sensitive. Unlike strcoll, strncmp is not affected by locale.
*/
